> For the complete documentation index, see [llms.txt](https://docs.platform9.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.platform9.com/managed-kubernetes/5.7/advanced-cluster-configuration/topology-manager.md).

# Topology Manager

The Topology Manager incorporates data from the CPU Manager and other device plugins when making decisions about pod placement. Without topology manager, CPU Manager and Device Manager make decisions independently and this can result in pod placements that are undesirable.

PMK now supports configuration of Topology Manager. The following fields are added to the cluster create API of **qbert**:

{% tabs %}
{% tab title="JSON" %}

```json
cpuManagerPolicy: {type: string, description: "options: none, static; default: none"},

topologyManagerPolicy: {type: string, description: "options: none, best-effort, restricted, single-numa-node; default: none"},

reservedCPUs: {type: string, description: "list of CPUs to be reserved for the system. Ex: 1-3,5"}
```

{% endtab %}
{% endtabs %}

The default value of the "cpuManagerPolicy" : "`none"` and will work for most applications.

When "`cpuManagerPolicy": "static"`turns on CPU Manager. This is required for Topology Manager to work.

Furthermore the `"topologyManagerPolicy"` supports the following options:

`* none`: Topology Manager is turned off

`* best-effort`: Kubelet uses hint providers to determine the best placement location for a pod. The pod is scheduled even if all affinity requirements are not met.

`* restricted`: Kubelet uses hint providers to determine the best placement location for a pod. The pod is terminated if such a node matching all affinity requirements are not met

`* single-numa-node`: Kubelet uses hint providers to find a single numa node that meets all affinity requirements. The pod is scheduled if such a node exists, it is moved to a terminated state otherwise. \\

You can read more about these policies [here](https://kubernetes.io/docs/tasks/administer-cluster/topology-manager/#topology-manager-policies).

`"reservedCPUs"` is a list of CPUs reserved for general purpose system use. Kubelet will not schedule pods to run on these CPUs.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.platform9.com/managed-kubernetes/5.7/advanced-cluster-configuration/topology-manager.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
